<!doctype html>
<html>
  <body>
  <h2>Les agencements</h2>
  <p>Les <i>layouts</i> en <i>Android</i> sont les agencements graphiques possibles
  pour une interface. Communément, un <i>layout</i> est placé à la racine du fichier
  XML représentant la vue. Il contient alors tous les éléments graphiques devant s'afficher
  sur l'interface.<br>
  Les principaux modèles d'agencement sont :
  <ul>
    <li><i>ConstraintLayout</i></li>
    <li><i>LinearLayout</i></li>
    <li><i>TableLayout</i>
    <li><i>GridLayout</i>
    <li><i>RelativeLayout</i>
  </ul>
</p>
<h3>ConstraintLayout</h3>
  <p>Le <i>ConstraintLayout</i> est l’évolution du <i>RelativeLayout</i>, comme
    tous les agencements, il hérite de <code>ViewGroup</code>. Il affiche des
    éléments graphiques à des positions relatives. <br>
    D’une part, il permet d’afficher un élément par rapport à un autre élément
    (à gauche ou en dessous d’un élément).<br>
     D’autre part, il permet d’afficher un élément par rapport à la zone d’affichage
     (aligné à gauche, en bas , au centre, etc.). <br>
     Ce type d’agencement est intéressant car il permet d’utiliser un seul
     <i>layout</i> là où il y en aurait besoin de plusieurs.</p>
<p>Concernant le <i>ConstraintLayout</i>, il y a deux types d’attributs.<br>
D’une part, il y a l’attribut de type <br><code>app :layout_constraintTop_toTopOf</code>,
prennant pour valeur <i>parent</i> :<br>
<code>app:layout_constraintTop_toTopOf="parent"</code><br>
Il place notre élément dans son parent soit dans l'écran. <br>
Dans la même veine, il y a : <br>
<ul>
  <li><code> app :layout_constraintStart_toStartOf</code></li>
  <li><code>app :layout_constraintEnd_toEndOf</code></li>
  <li><code>app :layout_constraintBottom_toBottomOf</code></li>
  <li><code>app :layout_constraintLeft_toLeftOf</code></li>
  <li><code>app :layout_constraintRight_RightOf</code></li>
</ul>
<br>
D’autre part, il y a l’attribut de type <br><code>app :layout_constraintTop_toBottomOf</code>,
prenant pour valeur l’identifiant d’un autre élément :<br>
<code>app:layout_constraintTop_toBottomOf="@id/itemText"</code><br>
Il place notre élément en dessous de l’autre élément.<br>
Dans la même veine, il y a :<br>
<ul>
  <li><code>app :layout_constraintBottom_toTopOf</code></li>
<li><code>app :layout_constraintStart_toEndOf </code></li>
<li><code>app :layout_constraintEnd_toStartOf </code></li>
<li><code>app :layout_constraintLeft_toRightOf </code></li>
<li><code>app :layout_constraintRight_toLeftOf</code></li>
</ul><br>
De manière générale, avec cet agencement, chaque élément a besoin d’un attribut
de placement vertical et un attribut de placement horizontal.</p>
<h4>Partie suivante</h4>
<a href="file:///android_asset/4-ressources.html">La gestion des ressources</a>
  </body>
</html>
